<?php
if (!defined('_PS_VERSION_')){
  exit;
 } 
require_once(dirname(__FILE__) . '/classes/Banner.php');  
  class DynamicBanner  extends Module
  
  { 
  
  public function __construct()
  {
    $this->name = 'dynamicbanner';
    $this->tab = 'front_office_features';
    $this->version = '1.0.0';
    $this->author = 'InnovativesLabs';
    $this->need_instance = 0;
    $this->ps_versions_compliancy = array('min' => '1.6', 'max' =>_PS_VERSION_);
    $this->bootstrap = true;
 
    parent::__construct();
 
    $this->displayName = $this->l('Dynamic Banner');
    $this->description = $this->l('Display dynamic banners in the home page.');
 
    $this->confirmUninstall = $this->l('Are you sure you want to uninstall?'); 
    
  }
  
  
  
  public function install()
{
  if (Shop::isFeatureActive())
    Shop::setContext(Shop::CONTEXT_ALL);
	$sql = array();
	
        $sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'dynamic_banner` (
                  `id_banner` int(10) unsigned NOT NULL AUTO_INCREMENT,                  
				  `banner_text` varchar(250) NOT NULL,
				  `banner_chiffre` varchar(250) NOT NULL,
				  `banner_img` varchar(250) NOT NULL,                  				  
                  PRIMARY KEY (`id_banner`)
                ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8';
	
	
 
  if (!parent::install() ||
    !$this->registerHook('DisplayNav') ||	
	!$this->registerHook('displayTopColumn')||
    !$this->registerHook('header')||
    !$this->runSql($sql)||
    !Configuration::updateValue('BANNER_INFO_TEXT','Quelques chiffres') 	
  )
    return false;
 
  return true;
}
       public function uninstall()
    {
        $sql = array();
	
        $sql[] = 'DROP TABLE IF EXISTS `'._DB_PREFIX_.'dynamic_banner`';
		
		if (!parent::uninstall()||
		    !$this->runSql($sql)||
            !Configuration::deleteByName('BANNER_INFO_TEXT')			
           )
                return false;
           $this->emptyUploads();
           return true;
    }
	
	
   public function runSql($sql) {
        foreach ($sql as $s) {
			if (!Db::getInstance()->Execute($s)){
				return FALSE;
			}
        }
        
        return TRUE;
    }	
  
        public function getContent()
    {
          $output = null;
		  
		 $this->addBanner();
		  
		    if (Tools::isSubmit('submit'.$this->name))
      {
        $my_module_name =strval(Tools::getValue('BANNER_INFO_TEXT'));
        if (!$my_module_name || empty($my_module_name) || !Validate::isGenericName($my_module_name))
            $output .= $this->displayError($this->l('Invalid Configuration value'));
        else
        {
            Configuration::updateValue('BANNER_INFO_TEXT', $my_module_name);
		
            $output.= $this->displayConfirmation($this->l('Settings updated'));
        }
      }  
		  
		  
		   if (Tools::isSubmit('deletedynamic_banner') && Tools::isSubmit('id'))
		{
		 $banner=new Banner((int)Tools::getValue('id'));
               $banner->delete();	
               $this->emptyCurrentImage(Tools::getValue('id'));			   
		} 

           if (Tools::isSubmit('updatedynamic_banner') && Tools::isSubmit('id'))
		{
		 
		 $output.=$this->renderUpdate();
               	 
		}  
		
		  
		elseif (Tools::isSubmit('viewdynamic_banner') && Tools::isSubmit('id'))
		{
		$output.=$this->renderOrders().'</br>'.$this->InnovativesLabs();		
		}
		   
		else
       {		
		   $output.=$this->displayForm().'</br>'.$this->renderNka().'</br>'.$this->renderList().'</br>'.$this->InnovativesLabs();
       }	
            return $output;
    }  


// list
      	public function renderList()
	{
		$fields_list = array(
		
		   'id' => array(
				'title' => $this->l('ID'),
				'search' => false,
			),
			'banner_text' => array(
				'title' => $this->l('Banner Text'),
				'search' => false,
			),			
			'banner_chiffre' => array(
				'title' => $this->l('Banner Chiffre'),
				'search' => false,
			),			
			'banner_img' => array(
				'title' => $this->l('Banner Image'),
				'search' => false,
			)
		);

		if (!Configuration::get('PS_MULTISHOP_FEATURE_ACTIVE'))
			unset($fields_list['shop_name']);
		$helper_list = New HelperList();
		$helper_list->module = $this;
		$helper_list->title = $this->l('Banner: Last added banner');
		$helper_list->shopLinkType = '';
		$helper_list->no_link = true;
		$helper_list->show_toolbar = true;
		$helper_list->simple_header = false;
		$helper_list->identifier = 'id';
		$helper_list->table = 'dynamic_banner';
		$helper_list->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name;
		$helper_list->token = Tools::getAdminTokenLite('AdminModules');
		$helper_list->actions = array('view','edit','delete');
		$helper_list->bulk_actions = array(
			'select' => array(
				'text' => $this->l('Change order status'),
				'icon' => 'icon-refresh',				
			)
		); 		

		// This is needed for displayEnableLink to avoid code duplication
		$this->_helperlist = $helper_list;

		/* Retrieve list data */
		$order=new Banner();
		$orders=$order->getAllBanners();
		$helper_list->listTotal = count($order->getAllBanners());

		/* Paginate the result */
		$page = ($page = Tools::getValue('submitFilter'.$helper_list->table)) ? $page : 1;
		$pagination = ($pagination = Tools::getValue($helper_list->table.'_pagination')) ? $pagination : 50;
		$orders = $this->paginateOrderProducts($orders, $page, $pagination);

		return $helper_list->generateList($orders, $fields_list);
		
	}
  
  //adding banners image
  
  	public function renderAddNewBannerForm()
	{
		$fields_form = array(
			'form' => array(
				'legend' => array(
					'title' => $this->l('Add a new Banner'),
					
				),
				'input' => array(
					array(
						'type' => 'text',
						'label' => $this->l('Banner title:'),
						'name' => 'BANNER_TEXT',
						'desc' => $this->l('add the title to display for this banner.'),
					),
					array(
						'type' => 'text',
						'label' => $this->l('Banner Chiffre:'),
						'name' => 'BANNER_CHIFFRE',
						'desc' => $this->l('Add the chiffre associated to this banner example: 156489+'),
					),
					array(
						'type' => 'file',
						'label' => $this->l('Banner Image:'),
						'name' => 'BANNER_IMAGE',
						'class' => 'fixed-width-sm',
						'desc' => $this->l('Add the banner associated image.'),
					),
				),
				'submit' => array(
					'title' => $this->l('Save'),
				)
			),
		);
		
		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table ='dynamic_banner';   // $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitAddnewBanner';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $helper->generateForm(array($fields_form));
	}
	
	public function getConfigFieldsValues()
	{
		return array(
			'BANNER_TEXT' => Tools::getValue('BANNER_TEXT', Configuration::get('BANNER_TEXT')),
			'BANNER_CHIFFRE' => Tools::getValue('BANNER_CHIFFRE', Configuration::get('BANNER_CHIFFRE')),
			'BANNER_IMAGE' => Tools::getValue('BANNER_IMAGE', Configuration::get('BANNER_IMAGE')),
		);
	}
  
  
  
  //end adding banners
  
  
  
  
   public function paginateOrderProducts($orders, $page = 1, $pagination = 50)
	{
		if(count($orders) > $pagination)
			$orders= array_slice($orders, $pagination * ($page - 1), $pagination);

		return $orders;
	}  
  

//list	
  
  
   public function hookDisplayNav($params)
	{
		return $this->hookTop($params);
	}
  
    
    public function hookTop($params)
    {
        return '';
		//return $this->renderFrontBanners();
    }
	
	
	public function hookdisplayTopColumn($params)
	{
		 return $this->renderFrontBanners();
		
	}
   
    
    public function hookDisplayHeader()
   {
        $this->context->controller->addCSS(($this->_path).'css/dynamic_banner.css', 'all');
    }  	
	
	   public function addBanner(){	
	   
	   $id_lang=(int)Context::getContext()->language->id; 
	   
     if(Tools::isSubmit('submitAddnewBanner')){         	 
		
        $BannerObj =new Banner();
        
		$BannerObj->banner_text=Tools::getValue('BANNER_TEXT');
		$BannerObj->banner_chiffre=Tools::getValue('BANNER_CHIFFRE');
		$BannerObj->banner_img=Tools::getValue('BANNER_IMAGE');
		
            if(!$BannerObj->add()){$messaege_alert="An error has occurred: Can\'t save the current object";	}
       else{
             $BannerObj->processImage($_FILES,$BannerObj->id);	
	    $image_url=$BannerObj->id.'-small_default.jpg';				
		$sql= 'UPDATE`'._DB_PREFIX_.'dynamic_banner` SET `banner_img`=\''.pSQL($image_url).'\' 
		       WHERE `id_banner`='.$BannerObj->id;                        
                  Db::getInstance()->execute($sql); 
        $messaege_alert="Your banner has been successfully added.";	
		
		}
      }  
	  
	  
   }
   
   
   
   public function renderFrontBanners(){
   
   $banner=new Banner();
   
   $this->context->smarty->assign(
      array(	      
		  'intro_text'=>Configuration::get('BANNER_INFO_TEXT'),
          'all_banners'=>$banner->getAllBanners() 		  
          
            )
               );  
  
	  
	  
         
       return $this->display(__FILE__, 'dynamic_banner.tpl');
   
   
   }
   
     public function renderOrders(){
  
    $id_customer=Tools::getValue('id');
    $orders=new Banner();	
    $this->context->smarty->assign(
      array(
	      
		  'id_customer'=>Tools::getValue('id'),		  
          'current_banner'=>$orders->getBannerDetails(),          		  
		  'url_back'=>AdminController::$currentIndex.'&configure='.$this->name.'&token='.Tools::getAdminTokenLite('AdminModules')
		  
          
            )
               );  
  
  return $this->display(__FILE__, 'view_banner.tpl');
  }
   
  public function  renderUpdate(){
  
  
        $id_banner=(int)Tools::getValue('id');
        $banner=new Banner($id_banner);
  if(Tools::isSubmit('submitUpdateBanner') && !empty($id_banner)){
        
		$banner->banner_text=Tools::getValue('banner_text');
		$banner->banner_chiffre=Tools::getValue('banner_chiffre');
		$banner->banner_img=Tools::getValue('banner_img');
		
       
	   $banner->update();
  } 
       	
	   
    $this->context->smarty->assign(
      array(	      
		  'id_banner'=>$id_banner,
          'banner'=>$banner,
          'update_token'=>Tools::getAdminTokenLite('AdminModules'),
          'url_back'=>AdminController::$currentIndex.'&configure='.$this->name.'&token='.Tools::getAdminTokenLite('AdminModules')          
            )
            );  
   
    return $this->display(__FILE__, 'edit_banner.tpl');
	
   }
   
    //emptying the uploads Directory after uninstall 
  public function emptyUploads(){   
     foreach (new DirectoryIterator('../modules/dynamicbanner/uploads') as $file) 
     @unlink('../modules/dynamicbanner/uploads/'.$file);   
  }  
   
   
   
    //emptying the uploads Directory after uninstall 
  public function emptyCurrentImage($id){   
     foreach (new DirectoryIterator('../modules/dynamicbanner/uploads') as $file) 
	 if (strpos($file, $id) !== false) {
     @unlink('../modules/dynamicbanner/uploads/'.$file);  
    }	 
  }  
   
  
  
  //for employee email 
  
  	   public function displayForm()
  {
    // Get default language
    $default_lang = (int)Configuration::get('PS_LANG_DEFAULT');
     
    // Init Fields form array
    $fields_form[0]['form'] = array(
        'legend' => array(
            'title' => $this->l('Settings'),
			'icon' => 'icon-cogs'
        ),
        'input' => array(
            array(
                'type' => 'text',
                'label' => $this->l('Banner intro text:'),
                'name' => 'BANNER_INFO_TEXT',
                'size' => 20,
                'required' => true
            )
        ),
        'submit' => array(
            'title' => $this->l('Save'),           
        )
    );
     
    $helper = new HelperForm();
     
    // Module, token and currentIndex
    $helper->module = $this;
    $helper->name_controller = $this->name;
    $helper->token = Tools::getAdminTokenLite('AdminModules');
    $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
     
    // Language
    $helper->default_form_language = $default_lang;
    $helper->allow_employee_form_lang = $default_lang;
     
    // Title and toolbar
    $helper->title = $this->displayName;
    $helper->show_toolbar = true;        // false -> remove toolbar
    $helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
    $helper->submit_action = 'submit'.$this->name;
    $helper->toolbar_btn = array(
        'save' =>
        array(
            'desc' => $this->l('Save'),
            'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
            '&token='.Tools::getAdminTokenLite('AdminModules'),
        ),
        'back' => array(
            'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
            'desc' => $this->l('Back to list')
        )
    );
     
    // Load current value
    $helper->fields_value['BANNER_INFO_TEXT'] = Configuration::get('BANNER_INFO_TEXT');
     
    return $helper->generateForm($fields_form);
    } 
  

  
  public function innovativesLabs(){
  
  return '';//$this->display(__FILE__, 'innovativeslabs.tpl');
  
  }
  
  
  
  public function renderNka(){
  
  $this->context->smarty->assign(
      array(	      
		  
          'token'=>Tools::getAdminTokenLite('AdminModules'),
          'url_back'=>AdminController::$currentIndex.'&configure='.$this->name.'&token='.Tools::getAdminTokenLite('AdminModules')          
            )
            ); 
   
   
   return $this->display(__FILE__, 'views/templates/admin/nka_form.tpl');
   
   
   }

  
  
  }

